/**
 *
 * @author Ester Dalvit
 * dalvit@science.unitn.it
 */
import java.awt.Color;
import java.util.Vector;

public class Strand {
    
    Vector<float[]> points;
    private float[] floatColor;
    
    public Strand() {
        points = new Vector<float[]>();
        floatColor = new float[3];
    }
    
    public int getLength() {
        return points.size();
    }
    
    public Vector<float[]> getPoints() {
        return points;
    }
    
    public float[] getPoint(int i) {
        return points.get(i);
    }
    
    public float[] getLastPoint() {
        return points.lastElement();
    }
    
    public void setPoint(int i, float[]newPoint) {
        points.get(i)[0] = newPoint[0];
        points.get(i)[1] = newPoint[1];
        points.get(i)[2] = newPoint[2];
    }
    
    public void removePoint(int i) {
        if (i<points.size())
            points.removeElementAt(i);
    }
    
    public void clear() {
        points.removeAllElements();
    }
    
    public void addPoint(int pos, float[]p) {
        if (pos<points.size()) {
            points.setSize(points.size()+1);
            points.add(pos, p);
        }
        else
            points.addElement(p);
    }
    
    public void addPoint(float v0, float v1, float v2) {
        float[]tmp = new float[3];
        tmp[0] = v0;
        tmp[1] = v1;
        tmp[2] = v2;
        addPoint(tmp);
    }
    
    public void addPoint(float[]p) {
        points.addElement(p);
    }
    
    public float[] getFloatColor() {
        return floatColor;
    }
    
    public void setFloatColor(Color c) {
        c.getRGBColorComponents(floatColor);
    }

    public void setFloatColor(float a, float b, float c) {
        floatColor[0] = a;
        floatColor[1] = b;
        floatColor[2] = c;
    }
}
