package model;

import util.*;
import java.awt.event.*;
import javax.swing.*;

import javax.media.opengl.*;
import com.sun.opengl.util.*;
import javax.media.opengl.glu.GLU;


public class Model 
	extends Trackball implements GLEventListener, MouseListener, MouseMotionListener, MouseWheelListener {

    protected int canvasWidth = 0,  canvasHeight = 0;
    protected FPSAnimator animator = null;
    public static Zoom zoom = new Zoom();

    public double cameraX, cameraY, cameraZ, lookAtX, lookAtY, lookAtZ;

    public static final GLU glu = new GLU();
	
	public GLCanvas canvas = null;
	public Trackball trackball = new Trackball();

	public Model() {
	    GLCapabilities glcaps = new GLCapabilities();
	    glcaps.setHardwareAccelerated(true);
	    canvas = new GLCanvas(glcaps);
        canvas.addGLEventListener(this);
	}

	// Methods required for the implementation of MouseListener
    @Override
	public void mouseEntered(MouseEvent e) {}
    @Override
	public void mouseExited(MouseEvent e) {}
    @Override
	public void mouseReleased(MouseEvent e) {}
    @Override
	public void mouseClicked(MouseEvent e) {}
    @Override
	public void mousePressed(MouseEvent e) {}
        
	// Methods required for the implementation of MouseMotionListener
    @Override
	public void mouseMoved(MouseEvent e) {}
    @Override
	public void mouseDragged(MouseEvent e) {}   
        
    public void mouseWheelMoved(MouseEvent e) {}
	
    public void init(GLAutoDrawable gld) {
        GL gl = gld.getGL();
        initLights(gl);

        gl.glLoadIdentity();

        gld.addMouseListener(this);
        gld.addMouseMotionListener(this);
        gld.addMouseWheelListener(this);
        trackball.listen(canvas);
//            zoom.listen(canvas);
        init(gl);
        animator = new FPSAnimator(gld,24);
        animator.start();
    }
        
    public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {
        final GLU aglu = new GLU();
        float ar = (float)width / (float)height;

        GL gl = drawable.getGL();       
        gl.glMatrixMode(GL.GL_PROJECTION);
        gl.glLoadIdentity();
        aglu.gluPerspective(zoom.getMaxZoom() - zoom.getZoom() + 10,(double)ar,0.01,60);
        gl.glMatrixMode(GL.GL_MODELVIEW);
        gl.glLoadIdentity();
        aglu.gluLookAt(
            cameraX, cameraY, cameraZ, // position
            lookAtX, lookAtY, lookAtZ, // look at
            0, 1, 0); // up vector
        canvasWidth = width;
        canvasHeight = height;
    }
	
    public void displayChanged(GLDrawable drawable, boolean modeChanged, boolean deviceChanged) {}

    public void display(GLAutoDrawable drawable) {	
        GL gl = drawable.getGL();
        final GLU aglu = new GLU();
        gl.glClearColor(0.05f,0f,0.1f,1.0f);
        gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);

        gl.glPushMatrix();

        gl.glMatrixMode(GL.GL_PROJECTION);
        gl.glLoadIdentity();
        aglu.gluPerspective(zoom.getMaxZoom() - zoom.getZoom() + 10,(double)canvasWidth/(double)canvasHeight,0.01,60);
        gl.glMatrixMode(GL.GL_MODELVIEW);
//	    gl.glLoadIdentity(); //////
//            glu.gluPerspective(zoom.getZoom(),(double)canvasWidth/(double)canvasHeight,0.01,30); //////
        gl.glMultMatrixf(trackball.getRotMatrix(), 0);
        redraw(gl);
        gl.glPopMatrix();

        gl.glPushMatrix();
        gl.glMatrixMode(GL.GL_PROJECTION);
        gl.glLoadIdentity();
        aglu.gluOrtho2D(-(double)canvasWidth/100,(double)canvasWidth/100,-(double)canvasHeight/100,(double)canvasHeight/100);

//        gl.glMatrixMode(GL.GL_MODELVIEW);
//        gl.glLoadIdentity();
//        draw2d(gl);
//        gl.glPopMatrix();
    }

	// override!
    public void redraw(GL gl) {}
    public void init(GL gl) {}
    public void initLights(GL gl) {}
    public JPanel createIndex() {
        return null;
    }
//    public void draw2d(GL gl) {}
	 
    public void displayChanged(GLAutoDrawable gLAutoDrawable, boolean b, boolean b0) {}

    @Override
    public void mouseWheelMoved(MouseWheelEvent e) {
    }
	
}

