package model;

import java.awt.BorderLayout;
import java.awt.Container;
import javax.swing.*;

public class ModelApplet extends JApplet {
    
    protected Model model = null;

    public ModelApplet(Model model) {
        super();
        this.model = model;
    }

    protected int getIntParameter(String name, int defaultValue) {
        try {
            return Integer.parseInt(getParameter(name));
  	} catch(Exception exception) {}
  	return defaultValue;  	
    }
  
    protected double getDoubleParameter(String name, double defaultValue) {
  	try {
            return Double.parseDouble(getParameter(name));
  	} catch(Exception exception) {}
  	return defaultValue;  	
    }
    
    protected boolean getBooleanParameter(String name, boolean defaultValue) {
  	try {
            String v = getParameter(name);
            return v.equals("on") || v.equals("true") || v.equals("yes");
  	} catch(Exception exception) {}
  	return defaultValue;  	
    }

    public void getFloatVector(float[]vector, int length, String name) {
        for (int i=0; i<length; i++) {
            vector[i] = (float)getDoubleParameter(name+"_"+i, 1);
        }
    }
  
    @Override
    public void init() {
        Container pane = getContentPane();
        pane.add(model.canvas, BorderLayout.CENTER);
//        JPanel pane1 = model.createControl();
//        if(pane1 != null) {
//            pane.add(pane1, BorderLayout.SOUTH);
//        }
        JPanel pane2 = model.createIndex();
        if(pane2 != null) {
            pane.add(pane2, BorderLayout.EAST);
        }
    }

    @Override
    public void stop() {
        //System.out.println("Applet stop");
        if (model.animator != null)
            model.animator.stop();
    }

    @Override
    public void destroy() {
    }
    
}

